//+---------------------------------------------------------------------+
//|                                                       NonLagAMA.mq5 | 
//|                                         Copyright  2009, edwinodus | 
//|                                                                     | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2009, edwinodus"
#property link "Copyright  2009, edwinodus"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1   DRAW_COLOR_LINE
//----      
#property indicator_color1  clrMagenta,clrGray,clrDeepSkyBlue
//----   -  
#property indicator_style1  STYLE_SOLID
//----     2
#property indicator_width1  2
//----   
#property indicator_label1  "NonLagAMA"

//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA;
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_=1,       //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price 
   PRICE_DEMARK_,        //Demark Price
   PRICE_NAVEL_          //Navel Price 
  };
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input uint Length0=12; //Length
input double Deviation=0; //Deviation
input uint Filter=0; //Filter
input Smooth_Method MA_Method1=MODE_SMA; //Smooth mode
input uint Length1=12; //Smooth length
input int Phase1=15; //Smooth phase
input Applied_price_ IPC=PRICE_CLOSE;//Price
input int Shift=0; // Shift
input int PriceShift=0; // Price shift
//+-----------------------------------+

//----   ,    
//      
double IndBuffer[];
double ColorIndBuffer[];

double Coeff,pi,Cycle,res1,res2,FPoint;
//----      
double dPriceShift;
//----      
int min_rates_total,Length0_,Len;
//----   
int Count[];
double Value[];
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos(int &CoArr[],//        
                          int Size)
  {
//----
   int numb,Max1,Max2;
   static int count=1;

   Max2=Size;
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//----
  }
//+------------------------------------------------------------------+   
//| NonLagAMA indicator initialization function                      | 
//+------------------------------------------------------------------+ 
void OnInit()
  {
//----     
   min_rates_total=XMA.GetStartBars(MA_Method1,Length1,Phase1);
//----       
   XMA.XMALengthCheck("Length1",Length1);
//----       
   XMA.XMAPhaseCheck("Phase1",Phase1,MA_Method1);

//----    
   dPriceShift=_Point*PriceShift;

   pi=3.1415926535;
//----
   Cycle=4;
   Coeff=3*pi;
   Length0_=int(MathMin(Length0-1,2));
   Len=int(Length0*Cycle+Length0_);  
   res1=1.0/(Length0_-1);   
   double res=Cycle*Length0-1;
   if(!res) res=1;
   res2=(2*Cycle-1)/res;
   FPoint=Filter*_Point;

//----       
   ArrayResize(Count,int(Len));
   ArrayResize(Value,int(Len));
//----
   ArrayInitialize(Count,0);
   ArrayInitialize(Value,0.0);

//----      
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----    1  
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);

//----     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);

//----           
   IndicatorSetString(INDICATOR_SHORTNAME,"NonLagAMA");

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+ 
//| NonLagAMA iteration function                                     | 
//+------------------------------------------------------------------+ 
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----       
   double price;
   double alfa,t,Sum,Weight,g;
//----        
   int first,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      price=PriceSeries(IPC,bar,open,low,high,close);
      Value[Count[0]]=XMA.XMASeries(0,prev_calculated,rates_total,MA_Method1,Phase1,Length1,price,bar,false);

      Weight=0;
      Sum=0;
      t=0;

      for(int iii=0; iii<Len; iii++)
        {
         g=1.0/(Coeff*t+1);
         if(t<=0.5) g=1;
         alfa=g*MathCos(pi*t);
         Sum+=alfa*Value[Count[iii]];
         Weight+=alfa;
         if(t<1) t+=res1;
         else if(t<Len-1) t+=res2;
        }
        
      if (Weight) IndBuffer[bar]=dPriceShift+(1.0+Deviation/100)*Sum/Weight;
      if(bar && MathAbs(IndBuffer[bar]-IndBuffer[bar-1])<FPoint) IndBuffer[bar]=IndBuffer[bar-1];
      if(bar<rates_total-1) Recount_ArrayZeroPos(Count,Len);
     }
//----    first
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=min_rates_total; //      

//----     
   for(bar=first; bar<rates_total; bar++)
     {
      ColorIndBuffer[bar]=1;
      if(IndBuffer[bar-1]<IndBuffer[bar]) ColorIndBuffer[bar]=2;
      if(IndBuffer[bar-1]>IndBuffer[bar]) ColorIndBuffer[bar]=0;
      if(IndBuffer[bar-1]==IndBuffer[bar]) ColorIndBuffer[bar]= ColorIndBuffer[bar-1];
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
